//////////////////////////////////////////////////////////////////////////////
//   ///////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "_DRAW_3D.h"
#include "_3D.h"
#include "_3D_Controller.h"

//////////////////////////////////////////////////////////////////////////////
//  -  ////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
int PaintRad = 12;

//////////////////////////////////////////////////////////////////////////////
//   /////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
void Falloff(int f) {  DrawRect(RegionFull(),RGBis(f,f,f),modeMUL); };
inline tfloat dist(tfloat x1, tfloat y1, tfloat x2, tfloat y2) {  x2 = x2 - x1; y2 = y2 - y1;  return sqrt(x2 * x2 + y2 * y2); };
inline dwRGB DIColor(dwRGB c, int m = 255) { return RGBmultV(c, DrawIntensityI * m / 255); };

//////////////////////////////////////////////////////////////////////////////
// () GArray //////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
class GArray
{ public:
  int xD, yD, vFilter, vColor, Mode; 
  tfloat vMin, vMax, vDelta, vRadL, vRandom, vRadDrawLim, Force;
  tfloat_arr *Value;
  dwRGB ColorD, ColorL;
  
  void filterUp()                             //  : 
  {
    for (int y = 0; y < yD - 1; y++)          //      
    for (int x = 0; x < xD; x++)(*Value)[y * xD + x] = (*Value)[(y + 1) * xD + x] + fRandom(-vRandom, vRandom); 
  };
  void filterDown()                           //  : 
  {
    for (int y = yD - 1; y > 1; y--)
    for (int x = 0; x < xD; x++)(*Value)[y * xD + x] = (*Value)[(y - 1) * xD + x] + fRandom(-vRandom, vRandom); 
  };
  void filterRight()                           //  : 
  {
    for (int y = 0; y < yD; y++) 
    for (int x = xD - 1; x > 1; x--)(*Value)[y * xD + x] = (*Value)[y * xD + x - 1] + fRandom(-vRandom, vRandom) ;  
  };
  void filterLeft()                           //  : 
  {
    for (int y = 0; y < yD; y++)
    for (int x = 0; x < xD - 1; x++)(*Value)[y * xD + x] = (*Value)[y * xD + x + 1] + fRandom(-vRandom, vRandom);
  };
  void Filter()                              //   []
  {
    switch(vFilter)
    { default: break;
      case 1: filterUp(); break;
      case 2: filterDown(); break;
      case 3: filterRight(); break;
      case 4: filterLeft(); break;
    };
  };
  void SetColor(int c)
  { vColor = c;
    switch(c)
    { case 0: ColorD = RGBis(0, 50, 170); ColorL = RGBis(15, 155, 255); break;
      case 1: ColorD = RGBis(105, 25, 0);  ColorL = RGBis(255, 150, 0);  break;
      case 2: ColorD = RGBis(105, 0, 25);  ColorL = RGBis(255, 0, 75);  break;
    };
  };
  void SetFilter(int f)  { vFilter = f; };
  void SetMinMax(tfloat mn, tfloat mx) { vMin = mn; vMax = mx; vDelta = vMax- vMin; };
  void Create()                              //  
  {
    xD = DrawXR / 8; yD = DrawYR  / 8;                      //    -
    Value = (tfloat_arr *)malloc(xD * yD * sizeof(tfloat)); //                  
    for (int i = 0; i < xD * yD; i++)(*Value)[i] = vMin;   //    
  };
  void Done() { free(Value); Value = NULL; };
  GArray()                                   // 
  {
    Mode = modeADD; vFilter = 0; SetColor(0); SetFilter(1); SetMinMax(0.25, 4);
    vRadL = 1.25; vRadDrawLim = 0; Value = NULL; Force = 0; vRandom = 0.15; 
  };
  ~GArray() { Done(); };                     //  
  void Paint(int x, int y, int rad, int sm = Yes)     // 
  { 
    if (sm) floatLinc(Force, 1, 0.0175); else Force = 1;
    tfloat r;
    int xx = (x - 4) / 8,           yy = (y - 4) / 8,
        x1 = max(xx - rad, 0),      y1 = max(yy - rad, 0),
        x2 = min(xx + rad, xD - 1), y2 = min(yy + rad, yD - 1); 
    for (int y = y1; y <= y2; y++)
    for (int x = x1; x <= x2; x++)
    { r = dist(xx, yy, x, y); 
      if (r < rad) floatLinc((*Value)[y * xD + x], vMax, Hermit((tfloat)(rad - r) / rad * Force));
    };  
  };
  void Draw()                                // 
  {
    tfloat *r;
    for (int y = 0; y < yD; y++)
    for (int x = 0; x < xD; x++)
    { r = &(*Value)[y * xD + x];
      *r = max(*r * 0.97 - 0.005, vMin);
      if (*r > vRadDrawLim)
      {  DrawCircle(4 + x * 8, 4 + y * 8, *r, DIColor(RGBblend(ColorD, ColorL,(*r - vMin) / vDelta * 255 + 0.5)), Mode); // :    
        if (*r > vRadL + 0.5) DrawCircle(4 + x * 8, 4 + y * 8, *r - (vMax - vRadL), DIColor(0xffffffff, 175), modeADD);
      };
    };  
    Force = max(Force * 0.9 - 0.0025, 0);
  };
};

//////////////////////////////////////////////////////////////////////////////
//  ////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
RandRotateCNT rrCNT[3][2];                  //  - 

GArray garray[3];

//////////////////////////////////////////////////////////////////////////////////////////////////
int keyExit = 0, HelpTimer = 0;

void keyPressed()                           //  [ ] 
{
  if (II.KeyUp[_CU_]) for (int i = 0; i < 3; i++) garray[i].SetFilter(1);
  if (II.KeyUp[_CD_]) for (int i = 0; i < 3; i++) garray[i].SetFilter(2); 
  if (II.KeyUp[_CR_]) for (int i = 0; i < 3; i++) garray[i].SetFilter(3); 
  if (II.KeyUp[_CL_]) for (int i = 0; i < 3; i++) garray[i].SetFilter(4);
  if (II.KeyUp[_Space_]) for (int i = 0; i < 3; i++) garray[i].SetFilter(0);
  if (II.KeyUp[_Del_]) for (int i = 0; i < 3; i++) if (garray[i].vRandom > 0.001) garray[i].vRandom = 0; else garray[i].vRandom = 0.1; 
  if (II.KeyUp[_F1_]) if (HelpTimer) HelpTimer = 0; else HelpTimer = 25 * 10;
  keyExit = (II.KeyUp[_Esc_]);
  II.Reset();
};


//////////////////////////////////////////////////////////////////////////////
//     /////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
TextSPR *info;

void CommonsInit()
{ RandomSeed();

  FC_FpsSet(AUTO);         //    
  FC_DrawPaint = Yes;      //  fps   DrawPaint();

  DrawPspMax = 3;                    //    
  DrawSetPspClipPlanes(-300); //    , ,     
                                     //   ,       
  //DrawSetFogPlanes(500,-115,effSEXPONENT); //     .

  Draw3D_Init();
  ForceActivate();
  ScreenLoadWait();

  info = new TextSPR(L"TYPE_EN_RU");

  OnKeyUpDo(keyPressed);       //     
  keyPressed();                //     ...
};


//////////////////////////////////////////////////////////////////////////////////////////////////
void CommonsDone()
{
  delete info;
  Draw3D_Done();
};

//////////////////////////////////////////////////////////////////////////////////////////////////
void DrawInfo()
{
  tRegion r = RegionCenterIs(208, 176);
  DrawRegionStore.Save(r);
  DrawRect(r, RGBis(50, 50, 50), modeMUL); 
  info->Place(0, 0, modeADD + fromCC, "Conrol Keys:\n\n\nCursor - set Move Direction\n\nSpace - set No Move\n\nDel - set On/Off Randomize\n.............................................................................\n\nF1 - hide/show Help\n\nEsc - Exit"); info->Draw();
};

//////////////////////////////////////////////////////////////////////////////////////////////////
void DrawPrepare(int i, int rad, int &x, int &y, int &r)
{ 
  OBJ.Current(10 + i);  
  tvect p = COBJ->QConv(tvect(0,0,0));
  tfloat k = DrawPspK(p.z); 
  x = p.x * k * DrawScale750 + DrawXC + 0.5;
  y = p.y * k * DrawScale750 + DrawYC + 0.5;
  r = rad * k * DrawScale750 + 0.5;
};

//////////////////////////////////////////////////////////////////////////////////////////////////
void DrawAll()
{
  int x, y, r;

  OBJs_RotateQDec();
  for (int i = 0; i < 3; i++)     //  
  { rrCNT[i][0].Regenerate(); rrCNT[i][1].Regenerate();
    DrawPrepare(i, PaintRad, x, y, r);
    garray[i].Paint(x, y, r, no);
    garray[i].Draw(); garray[i].Filter();
  };

  if (HelpTimer) DrawInfo();
  DrawPaint();
  if (HelpTimer) { DrawRegionStore.Restore();  HelpTimer--; };
};

//////////////////////////////////////////////////////////////////////////////
//   //////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
void Main()
{
  CommonsInit();                  //   ;  

  SetDrawIntensity(0.4);          //      
  //DrawScaleSet(1);              // 
  PaintRad = PaintRad * DrawScale * DrawYR / 1024 + 0.5; 

  for (int i = 0; i < 3; i++)     //     
  { OBJ.Current(10 + i);         //      -
    COBJ->SetOrient(RandOr);      // 
    COBJ->NoRotate();             //      
    COBJ->SetACenter(300,0,0);   //  2      ... ?
    COBJ->NextConv = 20 + i; 
    rrCNT[i][0].Node = 10 + i; rrCNT[i][0].SetRotate(Yes, Yes, m_PI/96, m_PI/48);

    OBJ.Current(20 + i); 
    COBJ->SetOrient(RandOr);
    COBJ->NoRotate();
    rrCNT[i][1].Node = 20 + i; rrCNT[i][1].SetRotate(Yes, Yes, m_PI/160, m_PI/96);

    garray[i].Create();           //   -
    garray[i].SetMinMax(0 ,4);
    garray[i].vRadDrawLim = 0.3;
    garray[i].SetColor(i);
    garray[i].vRandom = 0.1;
  };

  while (!keyExit)
   { Falloff(160);
      DrawAll();
   };   

  CommonsDone();                  //   ;
};
//////////////////////////////////////////////////////////////////////////////
int LetProcess()
{
  WinName = L"CG : Array";      //    
  VS_CColor = RGBis(0,0,0);    //   
  DrawSet(FullScreen);         //   ( )  , FullScreen   
  //SetDraw(640,480);
  ProcessFunc = Main;           //    -  
  return on;
};
int Init_LetProcess = LetProcess();

